\documentclass[a4paper,12pt,oneside]{book}
\usepackage[utf8]{inputenc}

\newcommand{\laTopic}       {Intro to Trees}
\newcommand{\laTitle}       {CS 250}
\renewcommand{\chaptername}{Part}
\renewcommand{\contentsname}{Contents - \laTopic}

\usepackage{../../latex-stuff/rachwidgets}
\usepackage{../../latex-stuff/rachdiagrams}

\title{}
\author{Rachel Singh}
\date{\today}

\pagestyle{fancy}
\fancyhf{}

\lhead{\laTopic \ / \laTitle}

\chead{}

\rhead{\thepage}

\rfoot{\tiny \thepage\ of \pageref{LastPage}}

\lfoot{\tiny Rachel Singh, last updated \today}

\renewcommand{\headrulewidth}{2pt}
\renewcommand{\footrulewidth}{1pt}

\toggletrue{answerkey}
%\togglefalse{answerkey}

\newcounter{question}

\begin{document}
        \tableofcontents

\chapter{Introduction}
    \begin{center}
        \includegraphics[width=0.4\textwidth]{images/tree.png}
    \end{center}

    \small
    \section{About}
        This exercise is to introduce you to Trees from a visual point of view.
        Make sure to use ``Chapter 5: Trees'' as a reference.
        The key is at the end of this document to check your work.
    
    \section{Turn-in instructions}
        \begin{itemize}
            \item   This assignment contains questions. You can print out
                    this document, or work freely on paper, or work digitally -
                    however you're able.
            \item   You will turn in the assignment on Canvas. You can photograph/scan
                    your paper work to turn in, or just save the document if
                    you work on the computer.
            \item   Please upload as .jpg files or a .pdf.
        \end{itemize}
        \normalsize
    
    
        \newpage
        
        \stepcounter{question}
        \begin{questionNOGRADE}{\thequestion \ - Node and Edge identification}
            Label the Nodes and Edges in the following diagram:
            
                \begin{center}
                    \begin{tikzpicture}
                        % Define points
                        \coordinate (root)  at (0.0,    0.0);
                            \coordinate (l)     at (-3,   -2.0);
                                \coordinate (ll)     at (-4.0,    -4.0);
                                \coordinate (lr)     at (-2.0,    -4.0);
                            \coordinate (r)     at (3,    -2.0);
                                \coordinate (rl)     at (2.0,    -4.0);
                                \coordinate (rr)     at (4.0,    -4.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (l) -- (root) -- (r);
                        \draw[-stealth,ultra thick,black]    (ll) -- (l) -- (lr);
                        \draw[-stealth,ultra thick,black]    (rl) -- (r) -- (rr);
                        
                        % Node circles
                        \filldraw[fill=white] (root)    circle (10pt) node{A};
                        \filldraw[fill=white] (l)       circle (10pt) node{B};
                        \filldraw[fill=white] (r)       circle (10pt) node{C};
                        \filldraw[fill=white] (ll)      circle (10pt) node{D};
                        \filldraw[fill=white] (lr)      circle (10pt) node{E};
                        \filldraw[fill=white] (rl)      circle (10pt) node{F};
                        \filldraw[fill=white] (rr)      circle (10pt) node{G};
                    \end{tikzpicture}   
                \end{center}
            
        \end{questionNOGRADE}
        
        \vspace{2cm}
        
        \stepcounter{question}
        \begin{questionNOGRADE}{\thequestion \ - Leaf, and Root identification}
            Label the leaf and root nodes in the following diagram:            
       
                \begin{center}
                    \begin{tikzpicture}
                        % Define points
                        \coordinate (root)  at (0.0,    0.0);
                            \coordinate (l)     at (-3,   -2.0);
                                \coordinate (ll)     at (-4.0,    -4.0);
                                \coordinate (lr)     at (-2.0,    -4.0);
                            \coordinate (r)     at (3,    -2.0);
                                \coordinate (rl)     at (2.0,    -4.0);
                                \coordinate (rr)     at (4.0,    -4.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (l) -- (root) -- (r);
                        \draw[-stealth,ultra thick,black]    (ll) -- (l) -- (lr);
                        \draw[-stealth,ultra thick,black]    (rl) -- (r) -- (rr);
                        
                        % Node circles
                        \filldraw[fill=white] (root)    circle (10pt) node{A};
                        \filldraw[fill=white] (l)       circle (10pt) node{B};
                        \filldraw[fill=white] (r)       circle (10pt) node{C};
                        \filldraw[fill=white] (ll)      circle (10pt) node{D};
                        \filldraw[fill=white] (lr)      circle (10pt) node{E};
                        \filldraw[fill=white] (rl)      circle (10pt) node{F};
                        \filldraw[fill=white] (rr)      circle (10pt) node{G};
                    \end{tikzpicture}   
                \end{center}
            
        \end{questionNOGRADE}
        
        \newpage
        \stepcounter{question}
        \begin{questionNOGRADE}{\thequestion \ - Ancestors and Descendants}
            Given the following tree:
            
                \begin{figure}[h]
                    \centering
                
                    \begin{tikzpicture}
                        % Define points
                        \coordinate (root)  at (0.0,    0.0);
                            \coordinate (c1)     at (-3,   -2.0);
                                \coordinate (c1c1) at (-5, -4.0);
                                    \coordinate (c1c1c1) at (-6, -6.0);
                                \coordinate (c1c2) at (-3, -4.0);
                                    \coordinate (c1c2c1) at (-4, -6.0);
                                    \coordinate (c1c2c2) at (-2, -6.0);
                                
                            \coordinate (c2)     at (0,   -2.0);
                                \coordinate (c2c1) at (-1, -4.0);
                                \coordinate (c2c2) at (1, -4.0);
                                
                            \coordinate (c3)     at (3,   -2.0);
                                \coordinate (c3c1) at (3, -4.0);
                                \coordinate (c3c2) at (6, -4.0);
                                    \coordinate (c3c2c1) at (4, -6.0);
                                    \coordinate (c3c2c2) at (6, -6.0);
                                    \coordinate (c3c2c3) at (8, -6.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (root) -- (c1);
                        \draw[-stealth,ultra thick,black]    (root) -- (c2);
                        \draw[-stealth,ultra thick,black]    (root) -- (c3);
                        \draw[-stealth,ultra thick,black]    (c1) -- (c1c1);
                        \draw[-stealth,ultra thick,black]    (c1c1) -- (c1c1c1);
                        \draw[-stealth,ultra thick,black]    (c1) -- (c1c2);
                        \draw[-stealth,ultra thick,black]    (c1c2) -- (c1c2c1);
                        \draw[-stealth,ultra thick,black]    (c1c2) -- (c1c2c2);
                        \draw[-stealth,ultra thick,black]    (c2) -- (c2c1);
                        \draw[-stealth,ultra thick,black]    (c2) -- (c2c2);
                        \draw[-stealth,ultra thick,black]    (c3) -- (c3c1);
                        \draw[-stealth,ultra thick,black]    (c3) -- (c3c2);
                        \draw[-stealth,ultra thick,black]    (c3c2) -- (c3c2c1);
                        \draw[-stealth,ultra thick,black]    (c3c2) -- (c3c2c2);
                        \draw[-stealth,ultra thick,black]    (c3c2) -- (c3c2c3);
                        
                        % Node circles
                        \node[rectangle,draw,fill=white] at (root) {Proto-indo-european};
                            \node[rectangle,draw,fill=white] at (c1)   {Indo-Iranian};
                                \node[rectangle,draw,fill=white] at (c1c1)   {Sanskrit};
                                    \node[rectangle,draw,fill=white] at (c1c1c1)   {Hindi};
                                \node[rectangle,draw,fill=white] at (c1c2)   {Persian};
                                    \node[rectangle,draw,fill=white] at (c1c2c1)   {Farsi};
                                    \node[rectangle,draw,fill=white] at (c1c2c2)   {Kurdish};
                            \node[rectangle,draw,fill=white] at (c2)   {Latin};
                                \node[rectangle,draw,fill=white] at (c2c1)   {French};
                                \node[rectangle,draw,fill=white] at (c2c2)   {Spanish};
                            \node[rectangle,draw,fill=white] at (c3)   {Germanic};
                                \node[rectangle,draw,fill=white] at (c3c1)   {Norse};
                                \node[rectangle,draw,fill=white] at (c3c2)   {West Germanic};
                                    \node[rectangle,draw,fill=white] at (c3c2c1)   {Dutch};
                                    \node[rectangle,draw,fill=white] at (c3c2c2)   {German};
                                    \node[rectangle,draw,fill=white] at (c3c2c3)   {Yiddish};
                    \end{tikzpicture}
                    \caption{\footnotesize An incomplete tree of language families related to Proto-Indo-European}
                \end{figure}
                
            Identify the following:
            
                \begin{center}
                    \begin{tabular}{| l l p{8cm} |}     \hline
                        a. & Children of Persian &      \\ & & \\ & & \\ & & \\ \hline
                        b. & Parent of French &         \\ & & \\ & & \\ & & \\ \hline
                        c. & Ancestors of Spanish &     \\ & & \\ & & \\ & & \\ \hline
                        d. & Descendants of Germanic &  \\ & & \\ & & \\ & & \\ \hline
                    \end{tabular}
                \end{center}
        \end{questionNOGRADE}
        
        \newpage
        \stepcounter{question}
        \begin{questionNOGRADE}{\thequestion \ - Heights}
            Given the following tree, identify the height:
            
                \begin{figure}[h]
                    \centering
                
                    \begin{tikzpicture}
                        % Define points
                        \coordinate (root)  at (0.0,    0.0);
                            \coordinate (c1)     at (-3,   -2.0);
                                \coordinate (c1c1) at (-5, -4.0);
                                    \coordinate (c1c1c1) at (-6, -6.0);
                                \coordinate (c1c2) at (-2, -4.0);
                                    \coordinate (c1c2c1) at (-4, -6.0);
                                    \coordinate (c1c2c2) at (-2, -6.0);
                                
                            \coordinate (c2)     at (0,   -2.0);
                                \coordinate (c2c2) at (1, -4.0);
                                
                            \coordinate (c3)     at (3,   -2.0);
                                \coordinate (c3c1) at (3, -4.0);
                                \coordinate (c3c2) at (6, -4.0);
                                    \coordinate (c3c2c1) at (4, -6.0);
                                    \coordinate (c3c2c2) at (6, -6.0);
                                    \coordinate (c3c2c3) at (8, -6.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (root) -- (c1);
                        \draw[-stealth,ultra thick,black]    (root) -- (c2);
                        \draw[-stealth,ultra thick,black]    (root) -- (c3);
                        \draw[-stealth,ultra thick,black]    (c1) -- (c1c1);
                        \draw[-stealth,ultra thick,black]    (c1c1) -- (c1c1c1);
                        \draw[-stealth,ultra thick,black]    (c1) -- (c1c2);
                        \draw[-stealth,ultra thick,black]    (c2) -- (c2c2);
                        
                        % Node circles
                        \node[rectangle,draw,fill=white] at (root) {Main menu};
                            \node[rectangle,draw,fill=white] at (c1)   {Play menu};
                                \node[rectangle,draw,fill=white] at (c1c1)   {Load game};
                                    \node[rectangle,draw,fill=white] at (c1c1c1)   {Level select};
                                \node[rectangle,draw,fill=white] at (c1c2)   {New game};
                            \node[rectangle,draw,fill=white] at (c2)   {Help menu};
                                \node[rectangle,draw,fill=white] at (c2c2)   {Credits};
                            \node[rectangle,draw,fill=white] at (c3)   {Exit};
                    \end{tikzpicture}
                    \caption{\footnotesize An example tree of screen navigation in a game.}
                \end{figure}
            
            \large
            Height = 
            \normalsize
            
        \end{questionNOGRADE}
        
        \stepcounter{question}
        \begin{questionNOGRADE}{\thequestion \ - Identify the height of each \textbf{subtree}:}
            \begin{center}
                \begin{tabular}{ | c | c | c |} \hline & & \\ & & \\
                    
                    \begin{tikzpicture}
                        % Define points                                
                            \coordinate (c2)     at (0,   -2.0);
                                \coordinate (c2c2) at (1, -4.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (c2) -- (c2c2);
                        
                        % Node circles
                            \node[rectangle,draw,fill=white] at (c2)   {Help menu};
                                \node[rectangle,draw,fill=white] at (c2c2)   {Credits};
                    \end{tikzpicture}
                    
                    &
                    
                    \begin{tikzpicture}
                        % Define points
                            \coordinate (c1)     at (-3,   -2.0);
                                \coordinate (c1c1) at (-5, -4.0);
                                    \coordinate (c1c1c1) at (-6, -6.0);
                                \coordinate (c1c2) at (-2, -4.0);
                                    \coordinate (c1c2c1) at (-4, -6.0);
                                    \coordinate (c1c2c2) at (-2, -6.0);
                                

                        % Edges
                        \draw[-stealth,ultra thick,black]    (c1) -- (c1c1);
                        \draw[-stealth,ultra thick,black]    (c1c1) -- (c1c1c1);
                        \draw[-stealth,ultra thick,black]    (c1) -- (c1c2);
                        
                        % Node circles
                            \node[rectangle,draw,fill=white] at (c1)   {Play menu};
                                \node[rectangle,draw,fill=white] at (c1c1)   {Load game};
                                    \node[rectangle,draw,fill=white] at (c1c1c1)   {Level select};
                                \node[rectangle,draw,fill=white] at (c1c2)   {New game};
                    \end{tikzpicture}
                    
                    &
                    
                    \begin{tikzpicture}
                        % Define points
                            \coordinate (c3)     at (3,   -2.0);

                        % Edges
                        
                        % Node circles
                            \node[rectangle,draw,fill=white] at (c3)   {Exit};
                    \end{tikzpicture}
                    
                    \\ & & \\
                    
                    Height =
                    &
                    Height =
                    &
                    Height =
                    
                    \\ & & \\ \hline
                \end{tabular}
            \end{center}

        \end{questionNOGRADE}
        
        
        \newpage
        \stepcounter{question}
        \begin{questionNOGRADE}{\thequestion \ - Tree traversals}
            Identify the preorder, inorder, and postorder traversal of the following binary tree:
            
                \begin{center}
                    \begin{tikzpicture}
                        % Define points
                        \coordinate (root)  at (0.0,    0.0);
                            \coordinate (l)     at (-3,   -2.0);
                                \coordinate (ll)     at (-4.0,    -4.0);
                                \coordinate (lr)     at (-2.0,    -4.0);
                            \coordinate (r)     at (3,    -2.0);
                                \coordinate (rl)     at (2.0,    -4.0);
                                \coordinate (rr)     at (4.0,    -4.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (l) -- (root) -- (r);
                        \draw[-stealth,ultra thick,black]    (ll) -- (l) -- (lr);
                        \draw[-stealth,ultra thick,black]    (rl) -- (r) -- (rr);
                        
                        % Node circles
                        \filldraw[fill=white] (root)    circle (10pt) node{A};
                        \filldraw[fill=white] (l)       circle (10pt) node{B};
                        \filldraw[fill=white] (r)       circle (10pt) node{E};
                        \filldraw[fill=white] (ll)      circle (10pt) node{C};
                        \filldraw[fill=white] (lr)      circle (10pt) node{D};
                        \filldraw[fill=white] (rl)      circle (10pt) node{F};
                        \filldraw[fill=white] (rr)      circle (10pt) node{G};
                    \end{tikzpicture}   
                \end{center}
                

                \begin{center}
                    \begin{tabular}{ | l l p{8cm} |} \hline
                        a. & Preorder:  & \\ & & \\ & &
                        \\ \hline
                        b. & Inorder:   & \\ & & \\ & &
                        \\ \hline
                        c. & Postorder: & \\ & & \\ & &
                        \\ \hline
                    \end{tabular}
                \end{center}
            
        \end{questionNOGRADE}
        
        \newpage
        \stepcounter{question}
        \begin{questionNOGRADE}{\thequestion \ - Tree traversals}
            Identify the preorder, inorder, and postorder traversal of the following binary tree:
            
                \begin{center}
                    \begin{tikzpicture}
                        % Define points
                        \coordinate (root)  at (0.0,    0.0);
                            \coordinate (l)     at (-3,   -2.0);
                                \coordinate (ll)     at (-4.0,    -4.0);
                                \coordinate (lr)     at (-2.0,    -4.0);
                            \coordinate (r)     at (3,    -2.0);
                                \coordinate (rl)     at (2.0,    -4.0);
                                \coordinate (rr)     at (4.0,    -4.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (l) -- (root) -- (r);
                        \draw[-stealth,ultra thick,black]    (ll) -- (l) -- (lr);
                        \draw[-stealth,ultra thick,black]    (rl) -- (r) -- (rr);
                        
                        % Node circles
                        \filldraw[fill=white] (root)    circle (10pt) node{D};
                        \filldraw[fill=white] (l)       circle (10pt) node{B};
                        \filldraw[fill=white] (r)       circle (10pt) node{F};
                        \filldraw[fill=white] (ll)      circle (10pt) node{A};
                        \filldraw[fill=white] (lr)      circle (10pt) node{C};
                        \filldraw[fill=white] (rl)      circle (10pt) node{E};
                        \filldraw[fill=white] (rr)      circle (10pt) node{G};
                    \end{tikzpicture}   
                \end{center}

                \begin{center}
                    \begin{tabular}{ | l l p{8cm} |} \hline
                        a. & Preorder:  & \\ & & \\ & &
                        \\ \hline
                        b. & Inorder:   & \\ & & \\ & &
                        \\ \hline
                        c. & Postorder: & \\ & & \\ & &
                        \\ \hline
                    \end{tabular}
                \end{center}
            
        \end{questionNOGRADE}
        \newpage
        \stepcounter{question}
        \begin{questionNOGRADE}{\thequestion \ - Tree traversals}
            Identify the preorder, inorder, and postorder traversal of the following binary tree:
            
                \begin{center}
                    \begin{tikzpicture}
                        % Define points
                        \coordinate (root)  at (0.0,    0.0);
                            \coordinate (l)     at (-3,   -2.0);
                                \coordinate (ll)     at (-4.0,    -4.0);
                                \coordinate (lr)     at (-2.0,    -4.0);
                            \coordinate (r)     at (3,    -2.0);
                                \coordinate (rl)     at (2.0,    -4.0);
                                \coordinate (rr)     at (4.0,    -4.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (l) -- (root) -- (r);
                        \draw[-stealth,ultra thick,black]    (ll) -- (l) -- (lr);
                        \draw[-stealth,ultra thick,black]    (rl) -- (r) -- (rr);
                        
                        % Node circles
                        \filldraw[fill=white] (root)    circle (10pt) node{G};
                        \filldraw[fill=white] (l)       circle (10pt) node{C};
                        \filldraw[fill=white] (r)       circle (10pt) node{F};
                        \filldraw[fill=white] (ll)      circle (10pt) node{A};
                        \filldraw[fill=white] (lr)      circle (10pt) node{B};
                        \filldraw[fill=white] (rl)      circle (10pt) node{D};
                        \filldraw[fill=white] (rr)      circle (10pt) node{E};
                    \end{tikzpicture}   
                \end{center}

                \begin{center}
                    \begin{tabular}{ | l l p{8cm} |} \hline
                        a. & Preorder:  & \\ & & \\ & &
                        \\ \hline
                        b. & Inorder:   & \\ & & \\ & &
                        \\ \hline
                        c. & Postorder: & \\ & & \\ & &
                        \\ \hline
                    \end{tabular}
                \end{center}
            
        \end{questionNOGRADE}
        
    \newpage
    \section{Solutions}
    
    \solution{
    
        \begin{enumerate}
            \item   \tab
                    \begin{mdframed}
                    \begin{tikzpicture}
                        % Define points
                        \coordinate (root)  at (0.0,    0.0);
                            \coordinate (l)     at (-3,   -2.0);
                                \coordinate (ll)     at (-4.0,    -4.0);
                                \coordinate (lr)     at (-2.0,    -4.0);
                            \coordinate (r)     at (3,    -2.0);
                                \coordinate (rl)     at (2.0,    -4.0);
                                \coordinate (rr)     at (4.0,    -4.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (l) -- (root) -- (r);
                        \draw[-stealth,ultra thick,black]    (ll) -- (l) -- (lr);
                        \draw[-stealth,ultra thick,black]    (rl) -- (r) -- (rr);
                        
                        % Node circles
                        \filldraw[fill=white] (root)    circle (10pt) node{A};
                        \filldraw[fill=white] (l)       circle (10pt) node{B};
                        \filldraw[fill=white] (r)       circle (10pt) node{C};
                        \filldraw[fill=white] (ll)      circle (10pt) node{D};
                        \filldraw[fill=white] (lr)      circle (10pt) node{E};
                        \filldraw[fill=white] (rl)      circle (10pt) node{F};
                        \filldraw[fill=white] (rr)      circle (10pt) node{G};
                        
                        % Answers
                        \node at (-2, 0) {Node};
                        \node at (-4, -2) {Node};
                        \node at (4, -2) {Node};
                        \node at (-4, -5) {Node};
                        \node at (-2, -5) {Node};
                        \node at (4, -5) {Node};
                        \node at (2, -5) {Node};
                        \node at (-2.5, -1) {Edge};
                        \node at (2.5, -1) {Edge};
                        \node at (-4.5, -3) {Edge};
                        \node at (-1.5, -3) {Edge};
                        \node at (4.5, -3) {Edge};
                        \node at (1.5, -3) {Edge};
                    \end{tikzpicture}   
                    \end{mdframed}
        
            \item   \tab
                    \begin{mdframed}
                    \begin{tikzpicture}
                        % Define points
                        \coordinate (root)  at (0.0,    0.0);
                            \coordinate (l)     at (-3,   -2.0);
                                \coordinate (ll)     at (-4.0,    -4.0);
                                \coordinate (lr)     at (-2.0,    -4.0);
                            \coordinate (r)     at (3,    -2.0);
                                \coordinate (rl)     at (2.0,    -4.0);
                                \coordinate (rr)     at (4.0,    -4.0);

                        % Edges
                        \draw[-stealth,ultra thick,black]    (l) -- (root) -- (r);
                        \draw[-stealth,ultra thick,black]    (ll) -- (l) -- (lr);
                        \draw[-stealth,ultra thick,black]    (rl) -- (r) -- (rr);
                        
                        % Node circles
                        \filldraw[fill=white] (root)    circle (10pt) node{A};
                        \filldraw[fill=white] (l)       circle (10pt) node{B};
                        \filldraw[fill=white] (r)       circle (10pt) node{C};
                        \filldraw[fill=white] (ll)      circle (10pt) node{D};
                        \filldraw[fill=white] (lr)      circle (10pt) node{E};
                        \filldraw[fill=white] (rl)      circle (10pt) node{F};
                        \filldraw[fill=white] (rr)      circle (10pt) node{G};
                        
                        % Answers
                        \node at (-2, 0) {root};
                        \node at (-4, -5) {leaf};
                        \node at (-2, -5) {leaf};
                        \node at (4, -5) {leaf};
                        \node at (2, -5) {leaf};
                    \end{tikzpicture}  
                    \end{mdframed}
                
            \item   
                    \begin{tabular}{| l l p{7cm} |}     \hline
                        a. & Children of Persian &      \small Farsi, Kurdish \\ \hline
                        b. & Parent of French &         \small Latin \\ \hline
                        c. & Ancestors of Spanish &     \small Latin, Proto-indo-european \\ \hline
                        d. & Descendants of Germanic &  \small West Germanic, Dutch, German, Yiddish, Norse \\ \hline
                    \end{tabular}
                    
            \item   Height = 3
            \item   Height = 1, Height = 2, Height = 0
            \item   
                    \begin{tabular}{ | l l p{8cm} |} \hline
                        a. & Preorder:  & ABCDEFG
                        \\ \hline
                        b. & Inorder:   & CBDAFEG
                        \\ \hline
                        c. & Postorder: & CDBFGEA
                        \\ \hline
                    \end{tabular}
            \item   
                    \begin{tabular}{ | l l p{8cm} |} \hline
                        a. & Preorder:  & DBACFEG
                        \\ \hline
                        b. & Inorder:   & ABCDEFG
                        \\ \hline
                        c. & Postorder: & ACBEGFD
                        \\ \hline
                    \end{tabular}
            \item   
                    \begin{tabular}{ | l l p{8cm} |} \hline
                        a. & Preorder:  & GCABFDE
                        \\ \hline
                        b. & Inorder:   & ACBGDFE
                        \\ \hline
                        c. & Postorder: & ABCDEFG
                        \\ \hline
                    \end{tabular}
            
        \end{enumerate}
    }{}
        
\end{document}

